unit DbFuncs;

interface

uses SysUtils, Classes, Variants, DB, DBTables, ScriptFuncs, ScriptParser,
  SysObjList;

type
  { TBDEQueryFunc }
  TBDEQueryFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TCreateHTMLTableFunc }
  TCreateHTMLTableFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEFieldNameFunc }
  TBDEFieldNameFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEFieldCountFunc }
  TBDEFieldCountFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEEofFunc }
  TBDEEofFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDENextFunc }
  TBDENextFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEValueFunc }
  TBDEValueFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEValueByNameFunc }
  TBDEValueByNameFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEIsNullFunc }
  TBDEIsNullFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDECloseFunc }
  TBDECloseFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEFieldsFunc }
  TBDEFieldsFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEFirstFunc }
  TBDEFirstFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEFieldsByNameFunc }
  TBDEFieldsByNameFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEFieldIsNullFunc }
  TBDEFieldIsNullFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEAsStringFunc }
  TBDEAsStringFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDECreateDatabaseFunc }
  TBDECreateDatabaseFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDECloseDatabaseFunc }
  TBDECloseDatabaseFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDELastFunc }
  TBDELastFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEExecuteFunc }
  TBDEExecuteFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDETableNamesFunc }
  TBDETableNamesFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEAliasNamesFunc }
  TBDEAliasNamesFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEDatabaseNamesFunc }
  TBDEDatabaseNamesFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEAliasParamsFunc }
  TBDEAliasParamsFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEDriverNamesFunc }
  TBDEDriverNamesFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEDriverParamsFunc }
  TBDEDriverParamsFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  { TBDEGetAliasNamesFunc }
  TBDEGetAliasNamesFunc = class(TScriptFunction)
  public
    constructor Create(AOwnerList: TScriptFunctionList); override;
    function Execute: Variant; override;
  end;

  {
  TMyQuery = class(TQuery)
  public
    destructor Destroy; override;
  end;
  }
  
implementation

uses CanApp;

{ RegisterDatabaseFunctions }
procedure RegisterDatabaseFunctions;
begin
  RegisterFunctions( [TBDEQueryFunc, TCreateHTMLTableFunc, TBDEFieldNameFunc,
    TBDEFieldCountFunc, TBDEEofFunc, TBDENextFunc, TBDEValueFunc,
    TBDEValueByNameFunc, TBDEIsNullFunc, TBDECloseFunc, TBDEFieldsFunc,
    TBDEFirstFunc, TBDEFieldsByNameFunc, TBDEFieldIsNullFunc,
    TBDEAsStringFunc, TBDECreateDatabaseFunc, TBDECloseDatabaseFunc,
    TBDELastFunc, TBDEExecuteFunc, TBDETableNamesFunc, TBDEAliasNamesFunc,
    TBDEDatabaseNamesFunc, TBDEAliasParamsFunc, TBDEDriverNamesFunc,
    TBDEGetAliasNamesFunc] );
end;

{ TBDEQueryFunc }

constructor TBDEQueryFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_Query';
  ResultType := idObject;
  with Params.AddParam do begin
    Name := '@TDatabase';
    ParamType := idObject;
  end;
  with Params.AddParam do begin
    Name := '@Query';
    ParamType := idString;
  end;
end;

function TBDEQueryFunc.Execute: Variant;
var
  Query: TQuery;
  SQLText: string;
  Database: TDatabase;
begin
  Result := Unassigned;
  Database := Params[0].ObjectValue as TDatabase;
  SQLText := Params[1].Value;
  Query := TQuery.Create(nil);
  try
    ObjectResult := Query;
    SystemObjectList.Add(Query);
    SQLText := Params[1].Value;
    Query.DatabaseName := Database.DatabaseName;
    Query.SQL.Clear;
    Query.SQL.Add(SQLText);
    Query.Open;
    Params[0].ObjectValue := nil;
    Params[0].Value := Unassigned;
    Params[1].Value := Unassigned;
  except
    on E: Exception do raise Exception.Create(E.Message);
  end;
end;

{ TCreateHTMLTableFunc }

constructor TCreateHTMLTableFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'CreateHTMLTable';
  ResultType := idObject;
  with Params.AddParam do begin
    Name := '@Database';
    ParamType := idString;
  end;
  with Params.AddParam do begin
    Name := '@Query';
    ParamType := idString;
  end;
  with Params.AddParam do begin
    Name := '@Template';
    ParamType := idString;
  end;
end;

function TCreateHTMLTableFunc.Execute: Variant;
var
  Query: TQuery;
  DatabaseName, SQLText, Template: string;
  Index: Integer;
  Text: string;
  Inverse: Boolean;
  RowText: string;
begin
  Result := Unassigned;
  Query := TQuery.Create(nil);
  try
    ObjectResult := Query;
    DatabaseName := Params[0].Value;
    SQLText := Params[1].Value;
    Template := Params[2].Value;
    Query.DatabaseName := DatabaseName;
    Query.SQL.Clear;
    Query.SQL.Add(SQLText);
    Query.Open;
    //with OutputStream do
    with Application do
    begin
      WriteString( '<tr class="classhead">' );
      for Index := 0 to Query.FieldCount - 1 do
      begin
        Text := '<th><a href="' + 'items.can?orderby=' +
          Query.Fields[Index].FieldName + '">' + Query.Fields[Index].FieldName + '</a></th>';
        WriteString( Text );
      end;
      WriteString( '</tr>' );
      Inverse := False;
      RowText := 'class=classrow1';
      while not Query.Eof do
      begin
        WriteString( '<tr>' );
        if Inverse then
        begin
          RowText := 'class=classrow2';
          Inverse := not Inverse;
        end
        else begin
          RowText := 'class=classrow1';
          Inverse := not Inverse;
        end;
        for Index := 0 to Query.FieldCount - 1 do
        begin
          if not Query.Fields[Index].IsNull then
            Text := '<td ' + RowText + '>' + Query.Fields[Index].AsString + '</td>'
          else
            Text := '<td ' + RowText + '>' + '&nbsp</td>';
          WriteString( Text );
        end;
        WriteString( '</tr>' );
        Query.Next;
      end;
    end;
    Query.Close;
    Params[0].Value := Unassigned;
    Params[1].Value := Unassigned;
    Params[2].Value := Unassigned;
  finally
    Query.Free;
  end;

end;

{ TBDEFieldNameFunc }

constructor TBDEFieldNameFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_FieldName';
  ResultType := idString;
  with Params.AddParam do begin
    Name := '@TField';
    ParamType := idObject;
  end;
end;

function TBDEFieldNameFunc.Execute: Variant;
var
  Field: TField;
begin
  Field := TField(Params[0].ObjectValue);
  Result := Field.FieldName;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDEFieldCountFunc }

constructor TBDEFieldCountFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_FieldCount';
  ResultType := idInteger;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
end;

function TBDEFieldCountFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
begin
  DBDataSet := TDBDataSet(Params[0].ObjectValue);
  Result := DBDataSet.Fields.Count;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDEEofFunc }

constructor TBDEEofFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_Eof';
  ResultType := idBoolean;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
end;

function TBDEEofFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
begin
  DBDataSet := TDBDataSet(Params[0].ObjectValue);
  Result := DBDataSet.Eof;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDENextFunc }

constructor TBDENextFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_Next';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
end;

function TBDENextFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
begin
  DBDataSet := TDBDataSet(Params[0].ObjectValue);
  DBDataSet.Next;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDEValueFunc }

constructor TBDEValueFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_Value';
  ResultType := idString;
  with Params.AddParam do begin
    Name := '@TField';
    ParamType := idObject;
  end;
end;

function TBDEValueFunc.Execute: Variant;
var
  Field: TField;
begin
  Field := TField(Params[0].ObjectValue);
  Result := Field.Value; // Don't forget. Value is Null problem!
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDEValueByNameFunc }

constructor TBDEValueByNameFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_ValueByName';
  ResultType := idString;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
  with Params.AddParam do begin
    Name := '@FieldName';
    ParamType := idString;
  end;
end;

function TBDEValueByNameFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
  FieldName: string;
begin
  DBDataSet := TDBDataSet(Params[0].ObjectValue);
  FieldName := Params[1].Value;
  Result := DBDataSet.FieldByName(FieldName).AsString;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
  Params[1].Value := Unassigned;
end;

{ TBDEIsNullFunc }

constructor TBDEIsNullFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_IsNull';
  ResultType := idString;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
  with Params.AddParam do begin
    Name := '@FieldNo';
    ParamType := idInteger;
  end;
end;

function TBDEIsNullFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
  FieldNo: Integer;
begin
  DBDataSet := TDBDataSet(Params[0].ObjectValue);
  FieldNo := Params[1].Value;
  Result := DBDataSet.Fields[FieldNo].IsNull;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
  Params[1].Value := Unassigned;
end;

{ TBDECloseFunc }

constructor TBDECloseFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_Close';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
end;

function TBDECloseFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
begin
  Result := Unassigned;
  DBDataSet := TDBDataSet(Params[0].ObjectValue);
  DBDataSet.Close;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDEFieldsFunc }

constructor TBDEFieldsFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_Fields';
  ResultType := idObject;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
  with Params.AddParam do begin
    Name := '@FieldNo';
    ParamType := idInteger;
  end;
end;

function TBDEFieldsFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
  Index: Integer;
  Field: TField;
begin
  Result := Unassigned;
  DBDataSet := TDBDataSet(Params[0].ObjectValue);
  Index := Params[1].Value;
  Field := DBDataSet.Fields[Index];
  ObjectResult := Field;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
  Params[1].Value := Unassigned;
end;

{ TBDEFirstFunc }

constructor TBDEFirstFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_First';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
end;

function TBDEFirstFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
begin
  DBDataSet := TDBDataSet(Params[0].ObjectValue);
  DBDataSet.First;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDEFieldsByNameFunc }

constructor TBDEFieldsByNameFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_FieldsByName';
  ResultType := idObject;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
  with Params.AddParam do begin
    Name := '@FieldName';
    ParamType := idString;
  end;
end;

function TBDEFieldsByNameFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
  FieldName: string;
  Field: TField;
begin
  Result := Unassigned;
  DBDataSet := TDBDataSet(Params[0].ObjectValue);
  FieldName := Params[1].Value;
  Field := DBDataSet.FieldByName(FieldName);
  ObjectResult := Field;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
  Params[1].Value := Unassigned;
end;

{ TBDEFieldIsNullFunc }

constructor TBDEFieldIsNullFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_FieldIsNull';
  ResultType := idString;
  with Params.AddParam do begin
    Name := '@TField';
    ParamType := idObject;
  end;
end;

function TBDEFieldIsNullFunc.Execute: Variant;
var
  Field: TField;
begin
  Field := TField(Params[0].ObjectValue);
  Result := Field.IsNull;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDEAsStringFunc }

constructor TBDEAsStringFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_AsString';
  ResultType := idString;
  with Params.AddParam do begin
    Name := '@TField';
    ParamType := idObject;
  end;
end;

function TBDEAsStringFunc.Execute: Variant;
var
  Field: TField;
begin
  Field := TField(Params[0].ObjectValue);
  Result := Field.AsString;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDECreateDatabaseFunc }

constructor TBDECreateDatabaseFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_CreateDatabase';
  ResultType := idObject;
  with Params.AddParam do begin
    Name := '@DB';
    ParamType := idString;
  end;
  with Params.AddParam do begin
    Name := '@UserName';
    ParamType := idString;
  end;
  with Params.AddParam do begin
    Name := '@Password';
    ParamType := idString;
  end;
end;

function TBDECreateDatabaseFunc.Execute: Variant;
var
  DatabaseName, UserName, Password: string;
  Database: TDatabase;
begin
  DatabaseName := Params[0].Value;
  UserName := Params[1].Value;
  Password := Params[2].Value;
  Database := TDatabase.Create(nil);
  try
    ObjectResult := Database;
    SystemObjectList.Add( Database );
    Database.LoginPrompt := False;
    Database.DatabaseName := DatabaseName;
    Database.Params.Add(Format('USER NAME=%s', [UserName]));
    Database.Params.Add(Format('PASSWORD=%s', [Password]));
    Database.Open;
  except
    on E: Exception do
      raise Exception.Create(E.Message);
  end;
  Params[0].Value := Unassigned;
  Params[1].Value := Unassigned;
  Params[2].Value := Unassigned;
end;

{ TBDECloseDatabaseFunc }

constructor TBDECloseDatabaseFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_CloseDatabase';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@TDatabase';
    ParamType := idObject;
  end;
end;

function TBDECloseDatabaseFunc.Execute: Variant;
var
  Database: TDatabase;
begin
  Database := Params[0].ObjectValue as TDatabase;
  Database.Close;
  Result := Unassigned;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDELastFunc }

constructor TBDELastFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_Last';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@RecordSet';
    ParamType := idObject;
  end;
end;

function TBDELastFunc.Execute: Variant;
var
  DBDataSet: TDBDataSet;
begin
  DBDataSet := Params[0].ObjectValue as TDBDataSet;
  DBDataSet.Last;
  Params[0].Value := Unassigned;
  Params[0].ObjectValue := nil;
end;

{ TBDEExecuteFunc }

constructor TBDEExecuteFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_Execute';
  ResultType := idObject;
  with Params.AddParam do begin
    Name := '@TDatabase';
    ParamType := idObject;
  end;
  with Params.AddParam do begin
    Name := '@SQLText';
    ParamType := idString;
  end;
end;

function TBDEExecuteFunc.Execute: Variant;
var
  Query: TQuery;
  SQLText: string;
  Database: TDatabase;
begin
  Result := Unassigned;
  Database := Params[0].ObjectValue as TDatabase;
  SQLText := Params[1].Value;
  Query := TQuery.Create(nil);
  try
    ObjectResult := Query;
    SystemObjectList.Add(Query); // Register to System Object list!
    SQLText := Params[1].Value;
    Query.DatabaseName := Database.DatabaseName;
    Query.SQL.Clear;
    Query.SQL.Add(SQLText);
    Query.ExecSQL;
    Params[0].ObjectValue := nil;
    Params[0].Value := Unassigned;
    Params[1].Value := Unassigned;
  except
    on E: Exception do raise Exception.Create(E.Message);
  end;
end;

{ TBDETableNamesFunc }

constructor TBDETableNamesFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_TableNames';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@TDatabase';
    ParamType := idObject;
  end;
  with Params.AddParam do begin
    Name := '@TStrings';
    ParamType := idObject;
  end;
  with Params.AddParam do begin
    Name := '@SystemTables';
    ParamType := idBoolean;
  end;
end;

function TBDETableNamesFunc.Execute: Variant;
var
  List: TStrings;
  Database: TDatabase;
  SystemTables: Boolean;
begin
  Result := Unassigned;
  try
    Database := Params[0].ObjectValue as TDatabase;
    List := Params[1].ObjectValue as TStrings;
    SystemTables := Params[2].Value;
    Database.GetTableNames( List, SystemTables );
    Params[0].ObjectValue := nil;
    Params[0].Value := Unassigned;
    Params[1].ObjectValue := nil;
    Params[1].Value := Unassigned;
    Params[2].Value := Unassigned;
  except
    on E: Exception do raise Exception.Create(E.Message);
  end;
end;

{ TBDEAliasNamesFunc }

constructor TBDEAliasNamesFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_AliasNames';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@TStrings';
    ParamType := idObject;
  end;
end;

function TBDEAliasNamesFunc.Execute: Variant;
var
  List: TStrings;
begin
  Result := Unassigned;
  List := Params[0].ObjectValue as TStrings;
  Session.GetAliasNames( List );
  Params[0].ObjectValue := nil;
  Params[0].Value := Unassigned;
end;

{ TBDEDatabaseNamesFunc }

constructor TBDEDatabaseNamesFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_DatabaseNames';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@TStrings';
    ParamType := idObject;
  end;
end;

function TBDEDatabaseNamesFunc.Execute: Variant;
var
  List: TStrings;
begin
  Result := Unassigned;
  List := Params[0].ObjectValue as TStrings;
  Session.GetDatabaseNames( List );
  Params[0].ObjectValue := nil;
  Params[0].Value := Unassigned;
end;

{ TBDEAliasParamsFunc }

constructor TBDEAliasParamsFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_AliasParams';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@AliasName';
    ParamType := idString;
  end;
  with Params.AddParam do begin
    Name := '@TStrings';
    ParamType := idObject;
  end;
end;

function TBDEAliasParamsFunc.Execute: Variant;
var
  AliasName: string;
  List: TStrings;
begin
  Result := Unassigned;
  AliasName := Params[0].Value;
  List := Params[1].ObjectValue as TStrings;
  Session.GetAliasParams( AliasName, List );
  Params[0].Value := Unassigned;
  Params[1].ObjectValue := nil;
  Params[1].Value := Unassigned;
end;

{ TBDEDriverNamesFunc }

constructor TBDEDriverNamesFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_DriverNames';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@TStrings';
    ParamType := idObject;
  end;
end;

function TBDEDriverNamesFunc.Execute: Variant;
var
  List: TStrings;
begin
  Result := Unassigned;
  List := Params[0].ObjectValue as TStrings;
  Session.GetDriverNames( List );
  Params[0].ObjectValue := nil;
  Params[0].Value := Unassigned;
end;

{ TBDEDriverParamsFunc }

constructor TBDEDriverParamsFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_DriverParams';
  ResultType := idUnknown;
  with Params.AddParam do begin
    Name := '@DriverName';
    ParamType := idString;
  end;
  with Params.AddParam do begin
    Name := '@TStrings';
    ParamType := idObject;
  end;
end;

function TBDEDriverParamsFunc.Execute: Variant;
var
  DriverName: string;
  List: TStrings;
begin
  Result := Unassigned;
  DriverName := Params[0].Value;
  List := Params[1].ObjectValue as TStrings;
  Session.GetDriverParams( DriverName, List );
  Params[0].Value := Unassigned;
  Params[1].ObjectValue := nil;
  Params[1].Value := Unassigned;
end;

{ TBDEGetAliasNamesFunc }

constructor TBDEGetAliasNamesFunc.Create(AOwnerList: TScriptFunctionList);
begin
  inherited Create(AOwnerList);
  Name := 'BDE_GetAliasNames';
  ResultType := idObject;
end;

function TBDEGetAliasNamesFunc.Execute: Variant;
var
  List: TStringList;
begin
  Result := Unassigned;
  List := TStringList.Create;
  try
    SystemObjectList.Add( List );
    Session.GetAliasNames( List );
    ObjectResult := List;
  except
  end;
end;

initialization
  RegisterDatabaseFunctions;

finalization

end.
