unit RespStrm;

interface

uses SysUtils, Classes;

type
  TResponseStream = class(TMemoryStream)
  private

  protected

  public
    procedure WriteString(const Text: string);
    function WriteClient(var Buffer; Count: LongInt): LongInt;
    procedure Flush;
  end;

var
  UseResponseBuffer: Boolean = False;
  Response: TResponseStream;

implementation

{ TResponseStream }

procedure TResponseStream.Flush;
var
  Buffer: array[0..4095] of Char;
  NumRead: LongInt;
begin

  Position := 0;
  repeat
    FillChar( Buffer, Sizeof(Buffer), 0 );
    NumRead := Read( Buffer, SizeOf(Buffer) );
    if NumRead > 0 then WriteClient( Buffer, NumRead );
  until Position >= Size;

end;

function TResponseStream.WriteClient(var Buffer; Count: Integer): LongInt;
begin
  Result := FileWrite(TTextRec(Output).Handle, Buffer, Count);
end;

procedure TResponseStream.WriteString(const Text: string);
begin
  if UseResponseBuffer then
    WriteBuffer( PChar(Text)^, Length(Text) )
  else
    WriteClient( PChar(Text)^, Length(Text) );
end;

end.
