
{*******************************************************}
{                                                       }
{       Borland Delphi Run-time Library                 }
{       Interface for the Windows light-weight          }
{       utility APIs                                    }
{                                                       }
{       Copyright (c) 1996,98 Datatech Corporation      }
{       Last update: 10/09/2006 10:27                   }
{*******************************************************}

unit Shlwapi;

interface

uses Windows;

{ String Functions }

{$EXTERNALSYM StrCpyA}
function StrCpyA(psz1, psz2: LPTSTR): LPTSTR; stdcall;
{$EXTERNALSYM StrCpyW}
function StrCpyW(psz1, psz2: LPCWSTR): LPCWSTR; stdcall;
{$EXTERNALSYM StrCpy}
function StrCpy(psz1, psz2: LPTSTR): LPTSTR; stdcall;

{$EXTERNALSYM StrCmpNIA}
function StrCmpNIA(lpstr1, lpstr2: LPTSTR; nChar: Integer): Integer; stdcall;
{$EXTERNALSYM StrCmpNIW}
function StrCmpNIW(lpstr1, lpstr2: LPCWSTR; nChar: Integer): Integer; stdcall;
{$EXTERNALSYM StrCmpNI}
function StrCmpNI(lpstr1, lpstr2: LPTSTR; nChar: Integer): Integer; stdcall;

{$EXTERNALSYM StrToIntA}
function StrToIntA(lpSrc: LPTSTR): Integer; stdcall;
{$EXTERNALSYM StrToIntW}
function StrToIntW(lpSrc: LPCWSTR): Integer; stdcall;
{$EXTERNALSYM StrToInt}
function StrToInt(lpSrc: LPTSTR): Integer; stdcall;

{$EXTERNALSYM StrTrimA}
function StrTrimA(psz: LPSTR; pszTrimChars: LPCSTR): BOOL; stdcall;
{$EXTERNALSYM StrTrimW}
function StrTrimW(psz: LPWSTR; pszTrimChars: LPCWSTR): BOOL; stdcall;
{$EXTERNALSYM StrTrim}
function StrTrim(psz: LPSTR; pszTrimChars: LPCSTR): BOOL; stdcall;

{$EXTERNALSYM StrFormatByteSizeA}
function StrFormatByteSizeA(dw: DWORD; pszBuf: LPSTR; cchBuf: UINT): LPTSTR; stdcall;
{$EXTERNALSYM StrFormatByteSizeW}
function StrFormatByteSizeW(qdw: int64; pszBuf: LPWSTR; cchBuf: UINT): LPTSTR; stdcall;
{$EXTERNALSYM StrFormatByteSize}
function StrFormatByteSize(dw: DWORD; pszBuf: LPSTR; cchBuf: UINT): LPTSTR; stdcall;

{ Path Functions }

{$EXTERNALSYM PathParseIconLocationA}
function PathParseIconLocationA(pszIconFile: LPTSTR): Integer; stdcall;
{$EXTERNALSYM PathParseIconLocationW}
function PathParseIconLocationW(pszIconFile: LPWSTR): Integer; stdcall;
{$EXTERNALSYM PathParseIconLocation}
function PathParseIconLocation(pszIconFile: LPTSTR): Integer; stdcall;

{$EXTERNALSYM PathFileExistsA}
function PathFileExistsA(pszPath: LPCTSTR): BOOL; stdcall;
{$EXTERNALSYM PathFileExistsW}
function PathFileExistsW(pszPath: LPCWSTR): BOOL; stdcall;
{$EXTERNALSYM PathFileExists}
function PathFileExists(pszPath: LPCTSTR): BOOL; stdcall;

{$EXTERNALSYM PathFindFileNameA}
function PathFindFileNameA(pPath: LPCTSTR): LPCTSTR; stdcall;
{$EXTERNALSYM PathFindFileNameW}
function PathFindFileNameW(pPath: LPCWSTR): LPCWSTR; stdcall;
{$EXTERNALSYM PathFindFileName}
function PathFindFileName(pPath: LPCTSTR): LPCTSTR; stdcall;

{$EXTERNALSYM PathFindNextComponentA}
function PathFindNextComponentA(pszPath: LPCTSTR): LPCTSTR; stdcall;
{$EXTERNALSYM PathFindNextComponentW}
function PathFindNextComponentW(pszPath: LPCWSTR): LPCWSTR; stdcall;
{$EXTERNALSYM PathFindFileName}
function PathFindNextComponent(pszPath: LPCTSTR): LPCTSTR; stdcall;

{ URL Functions }

{$EXTERNALSYM PathIsURLA}
function PathIsURLA(pszPath: LPCTSTR): BOOL; stdcall;
{$EXTERNALSYM PathIsURLW}
function PathIsURLW(pszPath: LPCWSTR): BOOL; stdcall;
{$EXTERNALSYM PathIsURL}
function PathIsURL(pszPath: LPCTSTR): BOOL; stdcall;

{$EXTERNALSYM UrlGetPartA}
function UrlGetPartA(pszIn: LPCTSTR; pszOut: LPTSTR; var pcchOut: DWORD;
  dwPart, dwFlags: DWORD): HRESULT; stdcall;
{$EXTERNALSYM UrlGetPartW}
function UrlGetPartW(pszIn: LPCWSTR; pszOut: LPWSTR; var pcchOut: DWORD;
  dwPart, dwFlags: DWORD): HRESULT; stdcall;
{$EXTERNALSYM UrlGetPart}
function UrlGetPart(pszIn: LPCTSTR; pszOut: LPTSTR; var pcchOut: DWORD;
  dwPart, dwFlags: DWORD): HRESULT; stdcall;

{
HRESULT UrlGetPart(
  LPCTSTR pszIn,
  LPTSTR pszOut,
  LPDWORD pcchOut,
  DWORD dwPart,
  DWORD dwFlags
);
}


const
  shlwapidll = 'shlwapi.dll';

implementation

{ String Functions }

{$EXTERNALSYM StrCpyA}
function StrCpyA(psz1, psz2: LPTSTR): LPTSTR;
begin
  Result := lstrcpyA(psz1, psz2);
end;

{$EXTERNALSYM StrCpyW}
function StrCpyW; external shlwapidll name 'StrCpyW';

{$EXTERNALSYM StrCpy}
function StrCpy(psz1, psz2: LPTSTR): LPTSTR;
begin
  Result := lstrcpy(psz1, psz2);
end;

{$EXTERNALSYM StrToIntA}
function StrToIntA; external shlwapidll name 'StrToIntA';
{$EXTERNALSYM StrToIntW}
function StrToIntW; external shlwapidll name 'StrToIntW';
{$EXTERNALSYM StrToInt}
function StrToInt; external shlwapidll name 'StrToIntA';

{$EXTERNALSYM StrCmpNIA}
function StrCmpNIA; external shlwapidll name 'StrCmpNIA';
{$EXTERNALSYM StrCmpNIW}
function StrCmpNIW; external shlwapidll name 'StrCmpNIW';
{$EXTERNALSYM StrCmpNI}
function StrCmpNI; external shlwapidll name 'StrCmpNIA';


{$EXTERNALSYM StrTrimA}
function StrTrimA; external shlwapidll name 'StrTrimA';
{$EXTERNALSYM StrTrimW}
function StrTrimW; external shlwapidll name 'StrTrimW';
{$EXTERNALSYM StrTrim}
function StrTrim; external shlwapidll name 'StrTrimA';

{$EXTERNALSYM StrFormatByteSizeA}
function StrFormatByteSizeA; external shlwapidll name 'StrFormatByteSizeA';
{$EXTERNALSYM StrFormatByteSizeW}
function StrFormatByteSizeW; external shlwapidll name 'StrFormatByteSizeW';
{$EXTERNALSYM StrFormatByteSize}
function StrFormatByteSize; external shlwapidll name 'StrFormatByteSizeA';

{ Path Functions }

{$EXTERNALSYM PathParseIconLocationA}
function PathParseIconLocationA; external shlwapidll name 'PathParseIconLocationA';
{$EXTERNALSYM PathParseIconLocationW}
function PathParseIconLocationW; external shlwapidll name 'PathParseIconLocationW';
{$EXTERNALSYM PathParseIconLocation}
function PathParseIconLocation; external shlwapidll name 'PathParseIconLocationA';

{$EXTERNALSYM PathFileExistsA}
function PathFileExistsA; external shlwapidll name 'PathFileExistsA';
{$EXTERNALSYM PathFileExistsW}
function PathFileExistsW; external shlwapidll name 'PathFileExistsW';
{$EXTERNALSYM PathFileExists}
function PathFileExists; external shlwapidll name 'PathFileExistsA';

{$EXTERNALSYM PathFindFileNameA}
function PathFindFileNameA; external shlwapidll name 'PathFindFileNameA';
{$EXTERNALSYM PathFindFileNameW}
function PathFindFileNameW; external shlwapidll name 'PathFindFileNameW';
{$EXTERNALSYM PathFindFileName}
function PathFindFileName; external shlwapidll name 'PathFindFileNameA';

{$EXTERNALSYM PathFindNextComponentA}
function PathFindNextComponentA; external shlwapidll name 'PathFindNextComponentA';
{$EXTERNALSYM PathFindNextComponentW}
function PathFindNextComponentW; external shlwapidll name 'PathFindNextComponentW';
{$EXTERNALSYM PathFindNextComponent}
function PathFindNextComponent; external shlwapidll name 'PathFindNextComponentA';

{ URL Functions }

{$EXTERNALSYM PathIsURLA}
function PathIsURLA; external shlwapidll name 'PathIsURLA';
{$EXTERNALSYM PathIsURLW}
function PathIsURLW; external shlwapidll name 'PathIsURLW';
{$EXTERNALSYM PathIsURL}
function PathIsURL; external shlwapidll name 'PathIsURLA';

{$EXTERNALSYM UrlGetPartA}
function UrlGetPartA; external shlwapidll name 'UrlGetPartA';
{$EXTERNALSYM UrlGetPartW}
function UrlGetPartW; external shlwapidll name 'UrlGetPartW';
{$EXTERNALSYM UrlGetPart}
function UrlGetPart; external shlwapidll name 'UrlGetPartA';

end.
