unit SysUnit;

interface

uses Windows, Messages, CommCtrl, WinSock, SysUtils, Classes;//, SystemUtils;

const
  CRLF = #13#10;

const
  ALIVE_TIMEOUT = 15000;
  CGI_TIMEOUT   = 30000;

var
  g_dwConnection    : DWORD = 0;
  g_dwReceive       : DWORD = 0;
  g_dwSend          : DWORD = 0;
  g_dwAliveTimeout  : DWORD = ALIVE_TIMEOUT;
  g_dwCgiTimeout    : DWORD = CGI_TIMEOUT;

const
  g_verMajor       = $1;
  g_verMinor       = $1;

const
  g_sHTTPVersion    = 'HTTP/1.1';
  g_sProtocol       = 'HTTP/1.1';
  g_sProtocolVer    = '1.1';
  g_sServerName     = 'Haysem HTTP Server 1.0';
  g_sGET            = 'GET';
  g_sPOST           = 'POST';
  g_sHEAD           = 'HEAD';
  g_sPUT            = 'PUT';
  g_sServer         = 'Server';
  g_sDate           = 'Date';
  g_sContentLength  = 'Content-Length';
  g_sConnection     = 'Connection';
  g_sKeepAlive      = 'Keep-Alive';
  g_sContentType    = 'Content-Type';
  g_sContent        = 'Content';
  g_sLastModified   = 'Last-Modified';
  g_sHost           = 'Host';
  g_sClose          = 'Close';
  g_sTextHtml       = 'text/html';

const
  EV_INFORMATION  = 0;
  EV_WARNING      = 1;
  EV_ERROR        = 2;
  EV_QUESTION     = 3;
  EV_HTMLFILE     = 4;
  EV_FOLDER       = 5;
  EV_OPENFOLDER   = 6;
  EV_EXECUTE      = 7;

const
  SC_DRAGMOVE    = $F012;

const
  // XP Style
  WS_EX_LAYERED = $00080000;
  LWA_ALPHA     = $00000002;
  LWA_COLORKEY  = $00000001;

  LVS_EX_DOUBLEBUFFER     = $00010000;
  LVS_EX_HIDELABELS       = $00020000;
  LVS_EX_SINGLEROW        = $00040000;
  LVS_EX_SNAPTOGRID       = $00080000;
  LVS_EX_SIMPLESELECT     = $00100000;

const
  user32 = 'user32.dll';

var
  g_WSAData: TWSADATA;
  g_wVersionRequested: Word;
  g_hWndMain: HWND;
  g_hWndRebar: HWND;
  g_hWndStatusBar: HWND;
  g_hWndActiveDlg: HWND = 0;
  g_hWndFocus: HWND;
  g_hWndToolBar: HWND;
  g_hMainMenu: HMENU;
  g_uConnections: UINT = 0;
  g_hImgListSmall  : HIMAGELIST; // 16x16
  g_hImgListNormal : HIMAGELIST; // 32x32
  g_hImgListLarge  : HIMAGELIST; // 48x48
  g_strHostName: string;
  g_dwViewStyle: DWORD = LVS_ICON;
  g_dwMainLeft: DWORD = CW_USEDEFAULT;
  g_dwMainTop: DWORD = CW_USEDEFAULT;
  //g_hbmWatermark: HBITMAP;

const
  COOKIE_LENGTH = 24;

const
  g_szClassName       = 'ANS-GenericClass';
  g_szCaption         = 'Haysem HTTP Server';
  IDI_MAINICON        = 101;
  IDM_MAINMENU        = 101;
  IDA_MAINACCEL       = 101;

  IDD_SERVER_DLG      = 101;
  IDD_EVENTS_DLG      = 102;
  IDD_STATISTICS_DLG  = 103;
  IDD_VIRHOSTS_DLG    = 104;
  IDD_ABOUT_DLG       = 105;

const
  IDM_START        = 40001;
  IDM_STOP         = 40002;
  IDM_PAUSE        = 40003;
  IDM_EXIT         = 40009;

  IDM_SERVER       = 40010;
  IDM_EVENTS       = 40011;
  IDM_STATISTICS   = 40012;
  IDM_VIRHOSTS     = 40013;

  IDM_ABOUT        = 40020;

const
  XP_CXICON = 48;
  XP_CYICON = 48;

var
  g_hAccel: HACCEL;

const
  strOptionsPathDB = 'Software\Datatech\HttpServer\1.0\Options';

{$EXTERNALSYM SetLayeredWindowAttributes}
function SetLayeredWindowAttributes(Hwnd: THandle; crKey: COLORREF;
  bAlpha: Byte; dwFlags: DWORD): Boolean; stdcall;

{ EventMessage }
procedure EventMessage(const strMsg: string);

{ ErrorMessage }
procedure ErrorMessage(const strMsg: string);

{ WarningMessage }
procedure WarningMessage(const strMsg: string);

{ InfoMessage }
procedure InfoMessage(const strMsg: string);

{ ExecuteMessage }
procedure ExecuteMessage(const strMsg: string);

{ BrowseMessage }
procedure BrowseMessage(const strMsg: string);

{ FormatErrorMessage }
function FormatErrorMessage(nErrorCode: DWORD): string;

{ DosPathToUnixPath }
function DosPathToUnixPath(const Path: string): string;

{ UnixPathToDosPath }
function UnixPathToDosPath(const Path: string): string;

{ GetContentType }
function GetContentType(const Ext: string): string;

{ GetStatusString }
function GetStatusString(StatusCode: Integer): string;

{ FormatSystemTimeGMT }
function FormatSystemTimeGMT(st: SYSTEMTIME): string;

{ HTTPDecode }
function HTTPDecode(const AStr: string): string;

{ HTTPEncode }
function HTTPEncode(const AStr: String): String;

{ URLToDocumentRoot }
function URLToDocumentRoot(const strHost, strURL: string): string;

{ VirtualHostExists }
function VirtualHostExists(const strHost: string): Boolean;

{ VirtualFolderDocumentRoot }
function VirtualFolderDocumentRoot(const strKey: string): string;

{ GetURLDocumentRoot }
function GetURLDocumentRoot(const strVirHost, strURL: string): string;

{ MapURLToPath }
function MapURLToPath(const strVirHost, strURL: string;
  var cchMatchingPath: DWORD; var cchMatchingURL: DWORD): string;

{ WebServerMapPath }
function WebServerMapPath(const strHost, strLogicalPath: string): string;

{ ServerMapPath }
function ServerMapPath(const strLogicalPath: string): string;

{ GetHostPart }
function GetHostPart(const Host: string): string;

{ CreateRebarControl }
function CreateRebarControl(hwndParent: HWND): HWND;

{ InsertBandControl }
function InsertBandControl(hwndRebar, hwndControl: HWND; Text: PChar;
  cyMin, cx: Integer): BOOL;

{ CreateStatusBar }
function CreateStatusBar(Wnd: HWND; const Parts: array of Integer): HWND;

{ GetHostName }
function GetHostName: string;

{ GetLocalAddress }
function GetLocalAddress: string;

{ StatusBarSetText }
function StatusBarSetText(const strText: string; iPart: Integer): Integer;

{ FormatDateTimeShort }
function FormatDateTimeShort( st: SYSTEMTIME ): string;

{ GetLocalDateTimeShort }
function GetLocalDateTimeShort: string;

{ GetLocalTimeShort }
function GetLocalTimeShort: string;

{ GetSystemDateTimeShort }
function GetSystemDateTimeShort: string;

{ GetSystemTimeShort }
function GetSystemTimeShort: string;

{ SystemInit }
procedure SystemInit;

{ GetRandomString }
function GetRandomString(dwChar: DWORD): string;

{ MakeSessionId }
function MakeSessionId(dwChar: DWORD): string;

{ SystemDone }
procedure SystemDone;

{ ExtractHeaderFields }
procedure ExtractHeaderFields(Separators, WhiteSpace: TSysCharSet; Content: PChar;
  Strings: TStrings; Decode: Boolean; StripQuotes: Boolean = False);

{ ExtractHTTPFields }
procedure ExtractHTTPFields(Separators, WhiteSpace: TSysCharSet; Content: PChar;
  Strings: TStrings; StripQuotes: Boolean = False);

{ GetExtensionType }
function GetExtensionType(const strExtension: string): DWORD;

{ GetExtensionEngine }
function GetExtensionEngine(const strExtension: string): string;

implementation

uses Activex, ShellApi, SysConst; //, SyncCount, 

const
  strHostRegKey = 'Software\Datatech\HttpServer\1.0\Virtual Hosts\';


procedure EventMessage( const strMsg: string );
begin
  //SendMessage( g_hwndMain, CM_SERVEREVENT, EV_INFORMATION, Integer(PChar(strMsg)) );
  //PostMessage( hwndMain, CM_SERVEREVENT, EV_INFORMATION, Integer(PChar(strMsg)) );
  //SendMessage( ghWndThread, CM_SERVEREVENT, EV_INFORMATION, Integer(PChar(strMsg)) );
  //EventLogMessage( '[Event] ' + strMsg + CRLF );
end;

procedure ErrorMessage( const strMsg: string );
begin
  //SendMessage( g_hwndMain, CM_SERVEREVENT, EV_ERROR, Integer(PChar(strMsg)) );
  //PostMessage( hwndMain, CM_SERVEREVENT, EV_ERROR, Integer(PChar(strMsg)) );
  //SendMessage( ghWndThread, CM_SERVEREVENT, EV_ERROR, Integer(PChar(strMsg)) );
  //EventLogMessage( '[Error] ' + strMsg + CRLF );
end;

procedure WarningMessage( const strMsg: string );
begin
  //SendMessage( g_hwndMain, CM_SERVEREVENT, EV_WARNING, Integer(PChar(strMsg)) );
  //PostMessage( hwndMain, CM_SERVEREVENT, EV_WARNING, Integer(PChar(strMsg)) );
  //SendMessage( ghWndThread, CM_SERVEREVENT, EV_WARNING, Integer(PChar(strMsg)) );
  //EventLogMessage( '[Warning] ' + strMsg + CRLF );
end;

procedure InfoMessage( const strMsg: string );
begin
  //SendMessage( g_hwndMain, CM_SERVEREVENT, EV_HTMLFILE, Integer(PChar(strMsg)) );
  //PostMessage( hwndMain, CM_SERVEREVENT, EV_HTMLFILE, Integer(PChar(strMsg)) );
  //SendMessage( ghWndThread, CM_SERVEREVENT, EV_HTMLFILE, Integer(PChar(strMsg)) );
  //EventLogMessage( '[Info] ' + strMsg + CRLF );
end;

procedure ExecuteMessage( const strMsg: string );
begin
  //SendMessage( g_hwndMain, CM_SERVEREVENT, EV_EXECUTE, Integer(PChar(strMsg)) );
  //PostMessage( hwndMain, CM_SERVEREVENT, EV_HTMLFILE, Integer(PChar(strMsg)) );
  //SendMessage( ghWndThread, CM_SERVEREVENT, EV_HTMLFILE, Integer(PChar(strMsg)) );
  //EventLogMessage( '[Info] ' + strMsg + CRLF );
end;

procedure BrowseMessage( const strMsg: string );
begin
  //SendMessage( g_hwndMain, CM_SERVEREVENT, EV_FOLDER, Integer(PChar(strMsg)) );
  //PostMessage( hwndMain, CM_SERVEREVENT, EV_HTMLFILE, Integer(PChar(strMsg)) );
  //SendMessage( ghWndThread, CM_SERVEREVENT, EV_HTMLFILE, Integer(PChar(strMsg)) );
  //EventLogMessage( '[Info] ' + strMsg + CRLF );
end;

function MakeLangID( p, s: Word ): DWORD;
begin
  Result := (s shl 10) or p;
end;

function FormatErrorMessage( nErrorCode: DWORD ): string;
var
  sMsgBuf: array[0..1024] of WideChar;
  nBytes: DWORD;
begin
  Result := '';
  FillChar( sMsgBuf, SizeOf( sMsgBuf ), 0 );
  nBytes := FormatMessageW(
    FORMAT_MESSAGE_FROM_SYSTEM or
    FORMAT_MESSAGE_IGNORE_INSERTS,
    nil,
    nErrorCode,
    MAKELANGID( LANG_NEUTRAL, SUBLANG_DEFAULT ),
    sMsgBuf,
    SizeOf( sMsgBuf ),
    nil );
  if nBytes > 0 then
    Result := WideCharToString( sMsgBuf );
  if Pos(#13#10, Result) > 0 then
    Result := Copy( Result, 1, Pos( #13#10, Result )-1 );
end;

{ TranslateChar }
function TranslateChar(const Str: string; FromChar, ToChar: Char): string;
var
  I: Integer;
begin
  Result := Str;
  for I := 1 to Length(Result) do
    if Result[I] = FromChar then
      Result[I] := ToChar;
end;

{ UnixPathToDosPath }
function UnixPathToDosPath(const Path: string): string;
begin
  Result := TranslateChar(Path, '/', '\');
end;

{ DosPathToUnixPath }
function DosPathToUnixPath(const Path: string): string;
begin
  Result := TranslateChar(Path, '\', '/');
end;

{ GetContentType }
function GetContentType(const Ext: string): string;
var
  Key: HKEY;
  dwSize: DWORD;
begin
  Result := '';
  if RegOpenKeyEx(HKEY_CLASSES_ROOT, PChar(Ext), 0, KEY_READ, Key) = ERROR_SUCCESS then
  begin
    dwSize := 0;
    if RegQueryValueEx(Key, 'Content Type', nil, nil,
			nil, @dwSize) = ERROR_SUCCESS then
    begin
      SetLength(Result, dwSize);
      if RegQueryValueEx(Key, 'Content Type', nil, nil,
			 PByte(Result), @dwSize) <> ERROR_SUCCESS then
        Result := '';
    end;

    if dwSize > 0 then
      SetLength(Result, dwSize-1);

    RegCloseKey(Key);
  end;
end;

{ GetStatusString }
function GetStatusString(StatusCode: Integer): string;
begin
  case StatusCode of
    100: Result := 'Continue';
    101: Result := 'Switching Protocols';
    200: Result := 'OK';
    201: Result := 'Created';
    202: Result := 'Accepted';
    203: Result := 'Non-Authoritative Information';
    204: Result := 'No Content';
    205: Result := 'Reset Content';
    206: Result := 'Partial Content';
    300: Result := 'Multiple Choices';
    301: Result := 'Moved Permanently';
    302: Result := 'Moved Temporarily';
    303: Result := 'See Other';
    304: Result := 'Not Modified';
    305: Result := 'Use Proxy';
    400: Result := 'Bad Request';
    401: Result := 'Unauthorized';
    402: Result := 'Payment Required';
    403: Result := 'Forbidden';
    404: Result := 'Not Found';
    405: Result := 'Method Not Allowed';
    406: Result := 'None Acceptable';
    407: Result := 'Proxy Authentication Required';
    408: Result := 'Request Timeout';
    409: Result := 'Conflict';
    410: Result := 'Gone';
    411: Result := 'Length Required';
    412: Result := 'Unless True';
    500: Result := 'Internal Server Error';
    501: Result := 'Not Implemented';
    502: Result := 'Bad Gateway';
    503: Result := 'Service Unavailable';
    504: Result := 'Gateway Timeout';
  else
    Result := '';
  end
end;

const
  // These strings are NOT to be resourced
  Months: array[1..12] of string = (
    SShortMonthNameJan, SShortMonthNameFeb, SShortMonthNameMar,
    SShortMonthNameApr, SShortMonthNameMay, SShortMonthNameJun,
    SShortMonthNameJul, SShortMonthNameAug, SShortMonthNameSep,
    SShortMonthNameOct, SShortMonthNameNov, SShortMonthNameDec
    );

  DaysOfWeek: array[0..6] of string = (
    SShortDayNameSun, SShortDayNameMon, SShortDayNameTue,
    SShortDayNameWed, SShortDayNameThu, SShortDayNameFri,
    SShortDayNameSat
    );

{ FormatSystemTimeGMT }
function FormatSystemTimeGMT( st: SYSTEMTIME ): string;
begin
  try
    Result := Format( '%s, %0.2d %s %0.4d %0.2d:%0.2d:%.02d GMT',
      [ DaysOfWeek[st.wDayOfWeek], st.wDay, Months[st.wMonth], st.wYear,
        st.wHour, st.wMinute, st.wSecond ] );
  except
    Result := '';
  end;
end;

{ HTTPDecode }
function HTTPDecode(const AStr: string): string;
var
  Sp, Rp, Cp: PChar;
begin
  try
    SetLength(Result, Length(AStr));
    Sp := PChar(AStr);
    Rp := PChar(Result);
    while Sp^ <> #0 do
    begin
      if not (Sp^ in ['+','%']) then
        Rp^ := Sp^
      else
        if Sp^ = '+' then
          Rp^ := ' '
        else
        begin
          Inc(Sp);
          if Sp^ = '%' then
            Rp^ := '%'
          else
          begin
            Cp := Sp;
            Inc(Sp);
            Rp^ := Chr(SysUtils.StrToInt(Format('$%s%s',[Cp^, Sp^])));
          end;
        end;
      Inc(Rp);
      Inc(Sp);
    end;
    SetLength(Result, Rp - PChar(Result));
  except
    Result := '';
  end;
end;

{ HTTPEncode }
function HTTPEncode(const AStr: String): String;
const
  NoConversion = ['A'..'Z','a'..'z','*','@','.','_','-',
                  '0'..'9','$','!','''','(',')'];
var
  Sp, Rp: PChar;
begin
  try
    SetLength(Result, Length(AStr) * 3);
    Sp := PChar(AStr);
    Rp := PChar(Result);
    while Sp^ <> #0 do
    begin
      if Sp^ in NoConversion then
        Rp^ := Sp^
      else
        if Sp^ = ' ' then
          Rp^ := '+'
        else
        begin
          FormatBuf(Rp^, 3, '%%%.2x', 6, [Ord(Sp^)]);
          Inc(Rp,2);
        end;
      Inc(Rp);
      Inc(Sp);
    end;
    SetLength(Result, Rp - PChar(Result));
  except
    Result := '';
  end;
end;

{ GetDocumentRoot }
function GetDocumentRoot(const strHost, strKey: string): string;
var
  Key: HKEY;
  dwSize: DWORD;
  strRegKey: string;
begin
  Result := '';
  strRegKey := strHostRegKey + strHost + strKey;
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE,
    PChar(strRegKey), 0, KEY_READ, Key) = ERROR_SUCCESS then
  begin
    dwSize := 0;
    if RegQueryValueEx(Key, 'Document Root', nil, nil,
			nil, @dwSize) = ERROR_SUCCESS then
    begin
      SetLength(Result, dwSize);
      if RegQueryValueEx(Key, 'Document Root', nil, nil,
			 PByte(Result), @dwSize) <> ERROR_SUCCESS then
        Result := '';
    end;

    if dwSize > 0 then
      SetLength(Result, dwSize-1);

    RegCloseKey(Key);
  end;
end;

{ PathFindPrevComponent }
function PathFindPrevComponent(const strPath: string; cChar: Char): string;
var
  Tail: PChar;
begin
  Result := '';
  Tail := StrRScan(PChar(strPath), cChar);
  if Tail <> nil then
    SetString(Result, PChar(strPath), Tail-PChar(strPath));
end;

{ FolderKeyExists }
function FolderKeyExists(const strHost, strKey: string): BOOL;
var
  Key: HKEY;
  strRegKey: string;
begin
  strRegKey := strHostRegKey + strHost + strKey;
  Result := (RegOpenKeyEx(HKEY_LOCAL_MACHINE,
    PChar(strRegKey), 0, KEY_READ, Key) = ERROR_SUCCESS);
  if Result then
    RegCloseKey(Key);
end;

{ URLPath }
function URLPath(const strURL: string): string;
begin
  Result := DosPathToUnixPath(ExtractFilePath(UnixPathToDosPath(strURL)));
end;

{ URLToDocumentRoot }
function URLToDocumentRoot(const strHost, strURL: string): string;
var
  strFind, strWinFolder: string;
begin

  Result := '';
  strFind := URLPath(strURL);
  strWinFolder := GetDocumentRoot(strHost, UnixPathToDosPath('/'));

  repeat
    if strFind[Length(strFind)] = '/' then
      Delete(strFind, Length(strFind), 1);
    if not FolderKeyExists(strHost, UnixPathToDosPath(strFind)) then
    begin
      strFind := PathFindPrevComponent(strFind, '/');
    end
    else begin
      strWinFolder := GetDocumentRoot(strHost, UnixPathToDosPath(strFind));
      Break;
    end;
  until strFind = '';

  if strWinFolder <> '' then
  begin
    if strWinFolder[Length(strWinFolder)] = '\' then
      Delete(strWinFolder, Length(strWinFolder), 1);
    Result := strWinFolder +
      UnixPathToDosPath(Copy(strURL, Length(strFind)+1, MaxInt));
  end;

end;

{ GetHomeDirectoy }
function GetHomeDirectoy(const strHost: string): string;
var
  Key: HKEY;
  dwSize: DWORD;
  strRegKey: string;
begin
  Result := '';
  strRegKey := strHostRegKey + strHost;
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE,
    PChar(strRegKey), 0, KEY_READ, Key) = ERROR_SUCCESS then
  begin
    dwSize := 0;
    if RegQueryValueEx(Key, 'Document Root', nil, nil,
			nil, @dwSize) = ERROR_SUCCESS then
    begin
      SetLength(Result, dwSize);
      if RegQueryValueEx(Key, 'Document Root', nil, nil,
			 PByte(Result), @dwSize) <> ERROR_SUCCESS then
        Result := '';
    end;

    if dwSize > 0 then
      SetLength(Result, dwSize-1);

    RegCloseKey(Key);
  end;
end;

{ ReverseFind }
function ReverseFind(const strStr: string; cChar: Char): Integer;
var
  Tail: PChar;
begin
  Result := 0;
  Tail := StrRScan( PChar(strStr), cChar );
  if Tail <> nil then
    Result := Tail - PChar(strStr) + 1;
end;

{ StripLast }
function StripLast(var strPath: string): string;
var
  nPos: Integer;
begin
  Result := '';
  if strPath <> '' then
  begin
    nPos := ReverseFind( strPath, '\' );
    if nPos = 0 then
      nPos := 1;
    Result := Copy( strPath, nPos, Length(strPath)-nPos+1 );
    strPath := Copy( strPath, 1, nPos-1 );
  end;
end;

{ GetURLDocumentRoot }
function GetURLDocumentRoot(const strVirHost, strURL: string): string;
var
  strFile: string;
  strExtra: string;
  bFind: Boolean;
begin
  Result := GetHomeDirectoy( strVirHost );
  strFile := UnixPathToDosPath( strURL );
  bFind := FolderKeyExists( strVirHost, strFile );
  if bFind then
    Result := GetDocumentRoot( strVirHost, strFile )
  else begin
    strExtra := StripLast( strFile );
    while strFile <> '' do
    begin
      bFind := FolderKeyExists( strVirHost, strFile );
      if bFind then Break;
      strExtra := StripLast( strFile ) + strExtra;
    end;
    Result := GetDocumentRoot( strVirHost, strFile ) + strExtra;
  end;
end;

{ VirtualHostExists }
function VirtualHostExists(const strHost: string): Boolean;
var
  strKey: string;
  Key: HKEY;
begin
  Result := False;
  strKey := strHostRegKey + strHost;
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(strKey), 0,
    KEY_READ, Key) = ERROR_SUCCESS then
  begin
    Result := True;
    RegCloseKey(Key);
  end;
end;

{ VirtualFolderDocumentRoot }
function VirtualFolderDocumentRoot(const strKey: string): string;
var
  Key: HKEY;
  dwSize: DWORD;
  strRegKey: string;
begin
  Result := '';
  strRegKey := strHostRegKey + strKey;
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE,
    PChar(strRegKey), 0, KEY_READ, Key) = ERROR_SUCCESS then
  begin
    dwSize := 0;
    if RegQueryValueEx(Key, 'Document Root', nil, nil,
			nil, @dwSize) = ERROR_SUCCESS then
    begin
      SetLength(Result, dwSize);
      if RegQueryValueEx(Key, 'Document Root', nil, nil,
			 PByte(Result), @dwSize) <> ERROR_SUCCESS then
        Result := '';
    end;

    if dwSize > 0 then
      SetLength(Result, dwSize-1);

    RegCloseKey(Key);
  end;
end;

{ MapURLToPath }
function MapURLToPath(const strVirHost, strURL: string;
  var cchMatchingPath: DWORD; var cchMatchingURL: DWORD): string;
var
  strFile: string;
  strExtra: string;
  bFind: Boolean;
begin
  // Bir daha bak. Bu kod pek hosuma gitmedi!
  Result := '';
  if (strURL = '') or (strVirHost = '') then Exit;
  Result := GetHomeDirectoy( strVirHost );
  if Result = '' then Exit;
  strFile := UnixPathToDosPath( strURL );
  bFind := FolderKeyExists( strVirHost, strFile );
  strExtra := '';
  if bFind then
    Result := GetDocumentRoot( strVirHost, strFile )
  else begin
    strExtra := StripLast( strFile );
    while strFile <> '' do
    begin
      bFind := FolderKeyExists( strVirHost, strFile );
      if bFind then begin
        Break;
      end;
      strExtra := StripLast( strFile ) + strExtra;
    end;
    Result := GetDocumentRoot( strVirHost, strFile );
  end;

  if Result <> '' then
    if Result[Length(Result)] = '\' then
      Delete(Result, Length(Result), 1);

  if strExtra <> '' then
    if strExtra[Length(strExtra)] = '\' then
      Delete(strExtra, Length(strExtra), 1);

  cchMatchingPath := Length(Result);
  cchMatchingURL := Length(strExtra);
  Result := Result + strExtra;

end;

{ WebServerMapPath }
function WebServerMapPath(const strHost, strLogicalPath: string): string;
var
  MatchPat, MatchURL: Cardinal;
begin
  Result := MapURLToPath( strHost, strLogicalPath, MatchPat, MatchURL )
end;

{ ServerMapPath }
function ServerMapPath(const strLogicalPath: string): string;
var
  strHost, strPath: string;
begin
  Result := '';

  if strLogicalPath = '' then Exit;
  
  if strLogicalPath[1] <> '/' then
  begin
    strPath := GetEnvironmentVariable( 'PATH_TRANSLATED' );
    strPath := ExtractFilePath( UnixPathToDosPath( strPath ) );
    Result := strPath + UnixPathToDosPath( strLogicalPath );
  end
  else begin
    strHost := GetEnvironmentVariable( 'HTTP_HOST' );
    strHost := LowerCase( GetHostPart( strHost ) );
    Result := WebServerMapPath( strHost, strLogicalPath );
  end;
  
end;

{ GetHostPart }
function GetHostPart(const Host: string): string;
var
  nColon: Integer;
begin
  Result := Host;
  nColon := Pos( ':', Result );
  if nColon > 0 then Result := Copy( Result, 1, nColon - 1 );
end;

{ CreateRebarControl }
function CreateRebarControl(hwndParent: HWND): HWND;
var
  rbi: TREBARINFO;
  icex: TINITCOMMONCONTROLSEX;
begin

  icex.dwSize := sizeof(TINITCOMMONCONTROLSEX);
  icex.dwICC  := ICC_COOL_CLASSES or ICC_BAR_CLASSES;
  InitCommonControlsEx(icex);

  Result := CreateWindowEx(WS_EX_TOOLWINDOW,
    REBARCLASSNAME,
    nil,
    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_CLIPCHILDREN or //WS_BORDER or
    CCS_NODIVIDER or CCS_NOPARENTALIGN or //CCS_VERT or CCS_LEFT or
    RBS_VARHEIGHT or RBS_BANDBORDERS or RBS_DBLCLKTOGGLE or RBS_AUTOSIZE,
    0,0,0,0,
    hwndParent,
    0,
    SysInit.hInstance,
    nil);

  // Initialize and send the REBARINFO structure.
  rbi.cbSize := sizeof(TREBARINFO);
  rbi.fMask  := 0;
  rbi.himl   := HIMAGELIST(nil);
  SendMessage( Result, RB_SETBARINFO, 0, LPARAM(@rbi) );

end;

{ InsertBandControl }
function InsertBandControl(hwndRebar, hwndControl: HWND; Text: PChar; cyMin, cx: Integer): BOOL;
var
  rbBand: TREBARBANDINFO;
begin
  Result := TRUE;
  // Set values unique to the band with the toolbar.
  FillChar(rbBand, SizeOf(TREBARBANDINFO), 0);
  rbBand.cbSize := SizeOf(TREBARBANDINFO);
  rbBand.fMask  := RBBIM_TEXT or
                   RBBIM_STYLE or RBBIM_CHILD or RBBIM_CHILDSIZE or
                   RBBIM_SIZE;
  rbBand.fStyle := RBBS_CHILDEDGE or RBBS_BREAK;// or RBBS_GRIPPERALWAYS;
  rbBand.lpText     := Text;
  rbBand.hwndChild  := hwndControl;
  rbBand.cxMinChild := 60;
  rbBand.cyMinChild := cyMin;
  rbBand.cx         := cx;

  // Add the band that has the toolbar.
  SendMessage( hwndRebar, RB_INSERTBAND, WPARAM(-1), LPARAM(@rbBand) );

end;

{ CreateStatusBar }
function CreateStatusBar(Wnd: HWND; const Parts: array of Integer): HWND;
var
  Style: Integer;
begin

  Result := CreateWindowEx(0,
    STATUSCLASSNAME,
    nil,
    WS_CHILD or WS_VISIBLE or CCS_BOTTOM,// or SBARS_SIZEGRIP,
    0, 0, 0, 0, Wnd, 0, hInstance, nil);

  SendMessage(Result, SB_SETPARTS, High(Parts) + 1, Integer(@Parts));

  Style := GetClassLong( Result, GCL_STYLE );
  Style := Style and not (CS_HREDRAW or CS_VREDRAW);
  SetClassLong( Result, GCL_STYLE, Style );

end;

{ GetHostName }
function GetHostName: string;
var
  sBuf: array[0..MAX_PATH] of Char;
begin
  FillChar( sBuf, SizeOf( sBuf ), 0 );
  Winsock.gethostname( sBuf, SizeOf( sBuf ) );
  SetString( Result, sBuf, lstrlen( sBuf ) );
end;

{ GetLocalAddress }
function GetLocalAddress: string;
var
  sBuf: array[0..MAX_PATH] of Char;
  pAddr: PInAddr;
  HostEnt: PHOSTENT;
  nRet, nLen: Integer;
begin

  nRet := Winsock.gethostname( sBuf, SizeOf( sBuf ) );

  if nRet = SOCKET_ERROR then
  begin
    sBuf[0] := #0;
    Exit;
  end;

  HostEnt := Winsock.gethostbyname( sBuf );

  if HostEnt = nil then
  begin
    sBuf[0] := #0;
    Exit;
  end;

  pAddr := PINADDR(HostEnt^.h_addr^);
  nLen := lstrlen( Winsock.inet_ntoa( pAddr^ ) );

  if DWORD(nLen) > SizeOf(sBuf) then
  begin
    WSASetLastError( WSAEINVAL );
    Exit;
  end;

  lstrcpy( sBuf, Winsock.inet_ntoa( pAddr^ ) );
  SetString( Result, sBuf, lstrlen( sBuf ) );

end;

{ StatusBarSetText }
function StatusBarSetText(const strText: string; iPart: Integer): Integer;
begin
  Result := SendMessage( g_hWndStatusBar, SB_SETTEXT, iPart,
    Integer(PChar(strText)) );
end;

{ FormatDateTimeShort }
function FormatDateTimeShort( st: SYSTEMTIME ): string;
begin
  Result := Format( '%0.2d/%0.2d/%0.4d %0.2d:%0.2d:%.02d',
    [ st.wDay, st.wMonth, st.wYear, st.wHour, st.wMinute, st.wSecond ] );
end;

{ FormatTimeShort }
function FormatTimeShort( st: SYSTEMTIME ): string;
begin
  Result := Format( '%0.2d:%0.2d:%.02d',
    [ st.wHour, st.wMinute, st.wSecond ] );
end;

{ GetLocalDateTimeShort }
function GetLocalDateTimeShort: string;
var
  st: _SYSTEMTIME;
begin
  GetLocalTime( st );
  Result := FormatDateTimeShort( st );
end;

{ GetLocalTimeShort }
function GetLocalTimeShort: string;
var
  st: _SYSTEMTIME;
begin
  GetLocalTime( st );
  Result := FormatTimeShort( st );
end;

{ GetSystemDateTimeShort }
function GetSystemDateTimeShort: string;
var
  st: _SYSTEMTIME;
begin
  GetSystemTime( st );
  Result := FormatDateTimeShort( st );
end;

{ GetSystemTimeShort }
function GetSystemTimeShort: string;
var
  st: _SYSTEMTIME;
begin
  GetSystemTime( st );
  Result := FormatTimeShort( st );
end;

(*
/*
 * Additional options.
 */
#define SO_SNDBUF       0x1001          /* send buffer size */
#define SO_RCVBUF       0x1002          /* receive buffer size */
#define SO_SNDLOWAT     0x1003          /* send low-water mark */
#define SO_RCVLOWAT     0x1004          /* receive low-water mark */
#define SO_SNDTIMEO     0x1005          /* send timeout */
#define SO_RCVTIMEO     0x1006          /* receive timeout */
#define SO_ERROR        0x1007          /* get error status and clear */
#define SO_TYPE         0x1008          /* get socket type */

/*
 * WinSock 2 extension -- new options
 */
#define SO_GROUP_ID       0x2001      /* ID of a socket group */
#define SO_GROUP_PRIORITY 0x2002      /* the relative priority within a group*/
#define SO_MAX_MSG_SIZE   0x2003      /* maximum message size */
#define SO_PROTOCOL_INFOA 0x2004      /* WSAPROTOCOL_INFOA structure */
#define SO_PROTOCOL_INFOW 0x2005      /* WSAPROTOCOL_INFOW structure */
*)

const
  SO_MAX_MSG_SIZE   = $2003;
  PVD_CONFIG        = $3001;

  MAX_MINICON = 10;
  uIconResMin: array[0..MAX_MINICON-1] of Integer = (
    193, 191, 192, 190, 195, 196, 105, 1603, 1115, 1116
    );

  MAX_IMAGE = 16;
  uImagesIndex: array[0..MAX_IMAGE-1] of Integer = (
    1902, 1903, 1904, 1905, 1906, 1907,
    1915, 1916, 1917, 1918,
    1919, 1920, 300, 301, 303, 105
    );

{ PrepareImageListFromResource }
procedure PrepareImageListFromResource;
var
  hResource: HMODULE;
  hiTemp: HICON;
  hbTemp: HBITMAP;
  iIndex: Integer;
begin
  hResource := LoadLibraryEx( 'resources.dll', 0, DONT_RESOLVE_DLL_REFERENCES );
  if hResource <> 0 then
  begin

    for iIndex := 0 to MAX_IMAGE-1 do
    begin
      hiTemp := LoadImage( hResource, MakeIntResource( uImagesIndex[iIndex] ),
        IMAGE_ICON, XP_CXICON, XP_CYICON, LR_DEFAULTCOLOR );
      if hiTemp <> 0 then begin
        ImageList_AddIcon( g_hImgListLarge, hiTemp );
        DestroyIcon( hiTemp );
      end;
    end;

    for iIndex := 0 to MAX_MINICON-1 do
    begin
      hiTemp := LoadImage( hResource, MakeIntResource( uIconResMin[iIndex] ),
        IMAGE_ICON, GetSystemMetrics(SM_CXICON),
        GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR );
      if hiTemp <> 0 then begin
        ImageList_AddIcon( g_hImgListNormal, hiTemp );
        DestroyIcon( hiTemp );
      end;
    end;

    for iIndex := 0 to MAX_MINICON-1 do
    begin
      hiTemp := LoadImage( hResource, MakeIntResource( uIconResMin[iIndex] ),
        IMAGE_ICON, GetSystemMetrics(SM_CXSMICON),
        GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR );
      if hiTemp <> 0 then begin
        ImageList_AddIcon( g_hImgListSmall, hiTemp );
        DestroyIcon( hiTemp );
      end;
    end;

    hbTemp := LoadBitmap( hResource, MAKEINTRESOURCE(216) );
    if hbTemp <> 0 then
    begin
      ImageList_Add( g_hImgListSmall, hbTemp, HBITMAP(0) );
      DeleteObject( hbTemp );
    end;

    FreeLibrary( hResource );

  end;
end;

{ InitImageLists }
procedure InitImageLists;
var
  shFile: SHFILEINFO;
  hLarge, hSmall: HICON;
begin

  g_hImgListSmall := ImageList_Create( GetSystemMetrics( SM_CXSMICON ),
    GetSystemMetrics( SM_CYSMICON ), ILC_COLOR32 or ILC_MASK, 4, 4 );

  g_hImgListNormal := ImageList_Create( GetSystemMetrics( SM_CXICON ),
    GetSystemMetrics( SM_CYICON ), ILC_COLOR32 or ILC_MASK, 24, 24 );

  g_hImgListLarge := ImageList_Create( XP_CXICON, XP_CYICON,
      ILC_COLOR32 or ILC_MASK, MAX_IMAGE, MAX_IMAGE );

  ImageList_AddIcon( g_hImgListNormal, LoadIcon( 0, IDI_ASTERISK ) );
  ImageList_AddIcon( g_hImgListNormal, LoadIcon( 0, IDI_EXCLAMATION ) );
  ImageList_AddIcon( g_hImgListNormal, LoadIcon( 0, IDI_HAND ) );
  ImageList_AddIcon( g_hImgListNormal, LoadIcon( 0, IDI_QUESTION ) );

  SHGetFileInfo( PChar('abc.html'), 0, shFile, SizeOf( shFile ),
    SHGFI_ICON or SHGFI_LARGEICON or SHGFI_USEFILEATTRIBUTES );
  ImageList_AddIcon( g_hImgListNormal, shFile.hIcon );
  DestroyIcon( shFile.hIcon );

  SHGetFileInfo( PChar('C:\WINDOWS'), 0, shFile, SizeOf( shFile ),
    SHGFI_ICON or SHGFI_LARGEICON );
  ImageList_AddIcon( g_hImgListNormal, shFile.hIcon );
  DestroyIcon( shFile.hIcon );

  SHGetFileInfo( PChar('C:\WINDOWS'), 0, shFile, SizeOf( shFile ),
    SHGFI_ICON or SHGFI_LARGEICON or SHGFI_OPENICON );
  ImageList_AddIcon( g_hImgListNormal, shFile.hIcon );
  DestroyIcon( shFile.hIcon );

  ImageList_AddIcon( g_hImgListSmall, LoadIcon( 0, IDI_ASTERISK ) );
  ImageList_AddIcon( g_hImgListSmall, LoadIcon( 0, IDI_EXCLAMATION ) );
  ImageList_AddIcon( g_hImgListSmall, LoadIcon( 0, IDI_HAND ) );
  ImageList_AddIcon( g_hImgListSmall, LoadIcon( 0, IDI_QUESTION ) );

  SHGetFileInfo( PChar('abc.html'), 0, shFile, SizeOf( shFile ),
    SHGFI_ICON or SHGFI_SMALLICON or SHGFI_USEFILEATTRIBUTES );
  ImageList_AddIcon( g_hImgListSmall, shFile.hIcon );
  DestroyIcon( shFile.hIcon );

  SHGetFileInfo( PChar('C:\WINDOWS'), 0, shFile, SizeOf( shFile ),
    SHGFI_ICON or SHGFI_SMALLICON );
  ImageList_AddIcon( g_hImgListSmall, shFile.hIcon );
  DestroyIcon( shFile.hIcon );

  SHGetFileInfo( PChar('C:\WINDOWS'), 0, shFile, SizeOf( shFile ),
    SHGFI_ICON or SHGFI_SMALLICON or SHGFI_OPENICON );
  ImageList_AddIcon( g_hImgListSmall, shFile.hIcon );
  DestroyIcon( shFile.hIcon );

  ExtractIconEx( 'shell32.dll', 169, hLarge, hSmall, 1 );
  ImageList_AddIcon( g_hImgListSmall, hSmall );
  ImageList_AddIcon( g_hImgListNormal, hLarge );
  DestroyIcon( hLarge );
  DestroyIcon( hSmall );

  ExtractIconEx( 'shell32.dll', 169+36, hLarge, hSmall, 1 );
  ImageList_AddIcon( g_hImgListSmall, hSmall );
  ImageList_AddIcon( g_hImgListNormal, hLarge );
  DestroyIcon( hLarge );
  DestroyIcon( hSmall );

  PrepareImageListFromResource;
  
end;

{ DoneImageLists }
procedure DoneImageLists;
begin
  //DeleteObject( g_hbmWatermark );
  ImageList_Destroy( g_hImgListSmall );
  ImageList_Destroy( g_hImgListNormal );
  ImageList_Destroy( g_hImgListLarge );
end;

function ReadRegDWordDB(const strKey: string): DWORD;
var
  Key: HKEY;
  dwSize: DWORD;
begin
  Result := DWORD(-1);
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(strOptionsPathDB), 0, KEY_READ, Key) = ERROR_SUCCESS then
  begin
    dwSize := SizeOf(Result);
    RegQueryValueEx(Key, PChar(strKey), nil, nil, PByte(@Result), @dwSize);
    RegCloseKey( Key );
  end;
end;

function WriteRegDWordDB(const strKey: string; dwValue: DWORD): DWORD;
var
  Key: HKEY;
  dwSize: DWORD;
begin
  Result := DWORD(-1);
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(strOptionsPathDB), 0, KEY_READ or KEY_WRITE, Key) = ERROR_SUCCESS then
  begin
    dwSize := SizeOf(dwValue);
    RegSetValueEx( Key, PChar(strKey), 0, REG_DWORD, PByte(@dwValue), dwSize );
    RegCloseKey( Key );
  end;
end;

function GetViewStyleDB: DWORD;
begin
  Result := ReadRegDWordDB( 'View Style' );
end;

procedure LoadOptions;
begin
  g_dwViewStyle := GetViewStyleDB;
  if g_dwViewStyle = DWORD(-1) then g_dwViewStyle := LVS_ICON;
end;

procedure SaveOptions;
begin
  WriteRegDWordDB( 'View Style', g_dwViewStyle );
end;

{ GetExtensionType }
function GetExtensionType(const strExtension: string): DWORD;
var
  Key: HKEY;
  dwSize: DWORD;
begin
  Result := DWORD(-1);
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE,
    PChar(strOptionsPathDB + '\Extensions\' + strExtension), 0,
    KEY_READ, Key) = ERROR_SUCCESS then
  begin
    dwSize := SizeOf(Result);
    RegQueryValueEx(Key, PChar('Type'), nil, nil, PByte(@Result), @dwSize);
    RegCloseKey( Key );
  end;
end;

{ GetExtensionEngine }
function GetExtensionEngine(const strExtension: string): string;
var
  Key: HKEY;
  dwSize: DWORD;
  strRegKey: string;
begin
  Result := '';
  strRegKey := strOptionsPathDB + '\Extensions\' + strExtension;
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(strRegKey), 0,
    KEY_READ, Key) = ERROR_SUCCESS then
  begin
    dwSize := 0;
    if RegQueryValueEx(Key, 'Engine', nil, nil,
			nil, @dwSize) = ERROR_SUCCESS then
    begin
      SetLength(Result, dwSize);
      if RegQueryValueEx(Key, 'Engine', nil, nil,
			 PByte(Result), @dwSize) <> ERROR_SUCCESS then
        Result := '';
    end;
    if dwSize > 0 then
      SetLength(Result, dwSize-1);
    RegCloseKey(Key);
  end;
end;

{ SystemInit }
procedure SystemInit;
begin

  g_wVersionRequested := MakeWord( 1, 1 );
  if WSAStartup( g_wVersionRequested, g_WSAData ) <> 0 then
  begin
    MessageBox( 0, 'Initialize WinSock Failed', 'HTTP Server', MB_OK or MB_ICONHAND );
    Halt( 1 );
  end;

  g_strHostName := GetHostName;

  InitCommonControls;
  CoInitialize( nil );

  InitImageLists;

  LoadOptions;

end;

{ SystemDone }
procedure SystemDone;
begin
  SaveOptions;
  DoneImageLists;
  WSACleanup();
  CoUninitialize();
end;

{ GetRandomString }
function GetRandomString(dwChar: DWORD): string;
const
  CHAR_MAP = 'qwertzuiopasdfghjklyxcvbnmQWERTZUIOPASDFGHJKLYXCVBNM1234567890';
var
  iIndex: integer;
  dwMaxChar: DWORD;
begin
  Randomize;
  dwMaxChar := Length( CHAR_MAP ) - 1;
  for iIndex := 1 to dwChar do
    Result := Result + CHAR_MAP[ Random(dwMaxChar) + 1 ];
end;

{ MakeSessionId }
function MakeSessionId(dwChar: DWORD): string;
const
  CHAR_MAP = 'QWERTZUIOPASDFGHJKLYXCVBNM';
var
  iIndex: integer;
  dwMaxChar: DWORD;
begin
  Randomize;
  dwMaxChar := Length( CHAR_MAP ) - 1;
  for iIndex := 1 to dwChar do
    Result := Result + CHAR_MAP[Random( dwMaxChar ) + 1];
  //Result := 'HAYSEMSESSIONID=' + Result;
end;

{ ExtractHeaderFields }
procedure ExtractHeaderFields(Separators, WhiteSpace: TSysCharSet; Content: PChar;
  Strings: TStrings; Decode: Boolean; StripQuotes: Boolean = False);
var
  Head, Tail: PChar;
  EOS, InQuote, LeadQuote: Boolean;
  QuoteChar: Char;

  function DoStripQuotes(const S: string): string;
  var
    I: Integer;
  begin
    Result := S;
    if StripQuotes then
      for I := Length(Result) downto 1 do
        if Result[I] in ['''', '"'] then
          Delete(Result, I, 1);
  end;

begin
  if (Content = nil) or (Content^ = #0) then Exit;
  Tail := Content;
  InQuote := False;
  QuoteChar := #0;
  repeat
    while Tail^ in WhiteSpace + [#13, #10] do Inc(Tail);
    Head := Tail;
    LeadQuote := False;
    while True do
    begin
      while (InQuote and (Tail^ <> '"')) or
        not (Tail^ in Separators + [#0, #13, #10, '"']) do Inc(Tail);
      if Tail^ = '"' then
      begin
        if (QuoteChar <> #0) and (QuoteChar = Tail^) then
          QuoteChar := #0
        else
        begin
          LeadQuote := Head = Tail;
          QuoteChar := Tail^;
          if LeadQuote then Inc(Head);
        end;
        InQuote := QuoteChar <> #0;
        if InQuote then
          Inc(Tail)
        else Break;
      end else Break;
    end;
    if not LeadQuote and (Tail^ <> #0) and (Tail^ = '"') then
      Inc(Tail);
    EOS := Tail^ = #0;
    Tail^ := #0;
    if Head^ <> #0 then
      if Decode then
        Strings.Add(DoStripQuotes(HTTPDecode(Head)))
      else Strings.Add(DoStripQuotes(Head));
    Inc(Tail);
  until EOS;
end;

{ ExtractHTTPFields }
procedure ExtractHTTPFields(Separators, WhiteSpace: TSysCharSet; Content: PChar;
  Strings: TStrings; StripQuotes: Boolean = False);
begin
  ExtractHeaderFields(Separators, WhiteSpace, Content, Strings, True, StripQuotes);
end;

{ SetLayeredWindowAttributes }
function SetLayeredWindowAttributes; external user32 name 'SetLayeredWindowAttributes';

end.
